//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * バイナリリーダヘッダ
 * @author Junpee
 */

#ifndef BINARY_READER_H_
#define BINARY_READER_H_

#include <Core/InputOutput/Reader.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * バイナリリーダ
 */
class BinaryReader : public Reader{
public:
	/**
	 * デストラクタ
	 */
	virtual ~BinaryReader();

	/**
	 * バイナリリーダの複製
	 * @return 複製されたバイナリリーダ
	 */
	virtual BinaryReader* cloneBinaryReader() = 0;

	/**
	 * リーダの複製
	 * @return 複製されたリーダ
	 */
	virtual Reader* cloneReader(){ return cloneBinaryReader(); }

	/**
	 * boolの読み込み
	 * @return 読み込んだ値
	 */
	virtual bool readBool();

	/**
	 * charの読み込み
	 * @return 読み込んだ値
	 */
	virtual char readChar();

	/**
	 * u_charの読み込み
	 * @return 読み込んだ値
	 */
	virtual u_char readUChar();

	/**
	 * shortの読み込み
	 * @return 読み込んだ値
	 */
	virtual short readShort();

	/**
	 * u_shortの読み込み
	 * @return 読み込んだ値
	 */
	virtual u_short readUShort();

	/**
	 * intの読み込み
	 * @return 読み込んだ値
	 */
	virtual int readInt();

	/**
	 * u_intの読み込み
	 * @return 読み込んだ値
	 */
	virtual u_int readUInt();

	/**
	 * floatの読み込み
	 * @return 読み込んだ値
	 */
	virtual float readFloat();

	/**
	 * doubleの読み込み
	 * @return 読み込んだ値
	 */
	virtual double readDouble();

	/**
	 * Stringの読み込み
	 * @return 読み込んだ文字列
	 */
	virtual const String readString();

	/**
	 * 配列の読み込み
	 * @param array 読み込み先配列
	 * @param elementSize 要素のサイズ
	 * @param elementCount 要素の数
	 */
	virtual void readArray(
		void* array, int elementSize, int elementCount);

protected:
	/**
	 * コンストラクタ
	 */
	BinaryReader();

private:

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of BINARY_READER_H_
//------------------------------------------------------------------------------
